{% extends "layout.html" %}
{% block content %}
<html lang="en">

<head>
    <meta charset="UTF-8">
    <title>WSI Annotator</title>
    <link rel="stylesheet" type="text/css" href="/static/mytemplate_with_comments.css" />
{#    <script type="text/javascript" src="{{ url_for('static', filename='jquery.js') }}"></script>#}
{#    for POST and GET#}
    <script type="text/javascript" src="{{ url_for('static', filename='jquery.min.js') }}"></script>
    <script type="text/javascript" src="{{ url_for('static', filename='openseadragon.js') }}"></script>
{#    <script type="text/javascript" src="{{ url_for('static', filename='openseadragon-scalebar.js') }}"></script> #}


</head>

<body style="width: 98%; height: 700px; float: left">
{#Refreshing function#}
{#<div class='container'>#}
{#    <h3>Refresh command</h3>#}
{#        <form>#}
{#            <a href=# id=process_input><button class='btn btn-default'>Refresh</button></a>#}
{#        </form>#}
{#    <p id=result></p>#}
{#</div>#}

{#OSD viewer#}

<div style="height: 100%; width: 100%; float: left">
    <h1 style="
        float: left;
        font-family: 'Sukhumvit Set';
        color: rgb(20%, 20%, 20%);
        width: 90%;
        margin: 5px auto 5px auto;
        padding: 5px 0 5px 15px;
        background-color: #bef1b8;
        border-radius: 10px 10px 0 0;
        ">
        Whole-Slide Image Annotator</h1>
    <form name="logout" action="/logout/" method="post">
        <input id="logout" type="submit" value="Logout">
    </form>
    <div id="openseadragon1" style="float: left; margin: 10px auto 10px auto; width: 800px; height: 450px;"></div>

    <div id="meta_data" ><b>meta_data</b></div>
	<div id="clinical_meta_data" >clinical_meta_data</div>
    <div id="patient_info">
        <button id="demographic">demographic</button>
        <p id="demographic_info" style="display:none"></p>
        <br>
        <button id="diagnosis">diagnosis</button>
        <p id="diagnosis_info" style="display:none"></p>
        <br>
        <button id="exposure">exposure</button>
        <p id="exposure_info" style="display:none"></p>
        <br>
        <button id="family_history">family_history</button>
        <p id="family_history_info" style="display:none"></p>
        <br>
        <button id="follow_up">follow_up</button>
        <p id="follow_up_info" style="display:none"></p>
        <br>
        <button id="molecular_test">molecular_test</button>
        <p id="molecular_test_info" style="display:none"></p>
        <br>
        <button id="treatment">mtreatment</button>
        <p id="treatment_info" style="display:none"></p>
    </div>

	<div id="bio_meta_data">biospecimen_meta_data</div>
	<div id="bio_info" style="padding:5px;background-color:#e5eecc;border:solid 1px #c3c3c3;float:right;width:500px;display:none">
        <button id="slide">slide</button>
        <p id="slide_info" style="display:none"></p>
        <br>
        <button id="sample">sample</button>
        <p id="sample_info" style="display:none"></p>
        <br>
        <button id="read_group">read_group</button>
        <p id="read_group_info" style="display:none"></p>
        <br>
        <button id="portion">portion</button>
        <p id="portion_info" style="display:none"></p>
        <br>
        <button id="analyte">analyte</button>
        <p id="analyte_info" style="display:none"></p>
        <br>
        <button id="aliquot">aliquot</button>
        <p id="aliquot_info" style="display:none"></p>
    </div>
    </div>

    <div style="float: left;margin: 10px auto 10px auto; width: 98%; font-family: 'Sukhumvit Set'">
        <div style="float: left;">Virtual Magnification: x<span id="mag_show"></span></div>

        <br>

        <h2 style="margin: 0 0 0 10px">Pre-segmentation level</h2>
            <div id="PS_lv" style="background-color: aquamarine; border-radius: 20px; padding: 10px;"></div>

        <h2 style="margin: 10px 0 0 10px">Tumor grading</h2>
            <div id="grading" style="background-color: goldenrod; border-radius: 20px; padding: 10px;"></div>

        <a href=# id=undo><button class='btn btn-default'>Undo</button></a>

        <div class="container">
            <h3>Annotator ID: </h3>
            <form>
                <input type=text size=5 name=anno_id>
                <a href=# id=anno_id><button class='btn btn-default'>Change Annotator</button></a>
            </form>
            <p id=annotator_result>Current annotator: unknown</p>
        </div>

        <div class="container">
            <h3>Slide ID: </h3>
            <form>
                <input type=text size=5 name=slide_id>
                <a href=# id=slide_id><button class='btn btn-default'>Change Slide</button></a>
            </form>

            <p id=slide_result>Current slide: unknown</p>
        </div>

        <div class="container">
            <h3>Screen Resolution: </h3>
            <form>
                <select id="sr", onchange="onScreenResSelect()">

                </select>
                <div id="sr_o">
                    width:
                    <input type=text size=5 id=sr_ox value="1920">
                    height:
                    <input type=text size=5 id=sr_oy value="1080">
                </div>
                <a href=# id=sr_update><button class='btn btn-default'>Update Resolution</button></a>
            </form>
        </div>

        <div class="container">
            <h3>Screen Size (inch): </h3>
            <form>
                <select id="ss", onchange="onScreenSizeSelect()">

                </select>
                <div id="ss_o">
                    size:
                    <input type=text size=5 id=ss_os value="24.0">
                </div>
                <a href=# id=ss_update><button class='btn btn-default'>Update Size</button></a>
            </form>
        </div>

        <div class="container">
            <h3>Distance from Screen (cm): </h3>
            <form>
                <select id="ds", onchange="onDistanceSelect()">

                </select>
                <div id="ds_o">
                    distance:
                    <input type=text size=6 id=ds_od value="50">
                </div>
                <a href=# id=ds_update><button class='btn btn-default'>Update Distance</button></a>
            </form>
        </div>

        <hr />

        <div class="container">
            <h3 style="margin-bottom: 5px">Viewing coordinates adjustment (for debugging): </h3>
            <form>
                <h4 style="margin-top: 5px; margin-bottom: 5px">Top-left (location): </h4>
                <span style="margin-left: 15px;">x:</span>
                <input type=text size=5 name=tl_x1 value="1200">

                 y:
                <input type=text size=5 name=tl_y1 value="1500">

                <h4 style="margin-top: 5px; margin-bottom: 5px">Viewing size: </h4>

                <span style="margin-left: 15px;">image width:</span>
                <input type=text size=5 name=tl_x2 value="1300">

                <a href=# id=update_img_man><button class='btn btn-default'>Update Image</button></a>
                <br />
                <span style="font-style: italic; font-size: 80%">The height of the image is automatically calculated based on the width
                and the specified viewer size. </span>
            </form>
        </div>

        <hr />

        <p id=slide_result>Current slide: unknown</p>

        <a href=# id=tog_boun><button class='btn btn-default'>Toggle boundary</button></a>
        <p id="tog_result">Toggle switch: ON</p>

    </div>
</div>

<script type="text/javascript">
    // Disable right-click
    window.oncontextmenu=function(e){
        e.preventDefault();
    };

    var data_draw = {}; //recording the points -> should be JSON
    var point_number=0; //the length of data_draw

    var MAX_X=5000,MAX_Y=5000; // Default max value
	var UpLeft_X=0,UpLeft_Y=0; //coordinate of UpLeft (top-left coor)
    var X=5000,Y=5000;// width and height that the image asked for(change automatically)
    var DownRight_X=UpLeft_X+X,DownRight_Y=UpLeft_Y+Y;//coordinate of DownRight (bottom-right coor)

	var OCD_X_PX=1000,OCD_Y_PX=1000; //wide and length asking for (viewing image size)
    var ps_lv = 0, MAX_ps_lv = 2; // Max is 6
    var grading=0, Max_grading=3;

    var keyboard=['Z','X','C','V','B','N','M']; //control the ps_lv

    var buffer = 0.05;

    var enableOverlay = false;

    var screen_res = [[160, 120], [240, 160], [320, 240], [400, 240], [480, 320], [640, 360], [640, 480], [768, 480], [800, 600], [854, 480], [960, 540], [960, 640], [1024, 576], [1024, 600], [1024, 768], [1152, 864], [1280, 720], [1280, 1024], [1366, 768], [1400, 1050], [1440, 900], [1600, 1200], [1680, 1050], [1920, 1080], [1920, 1200], [2048, 1152], [2048, 1536], [2560, 1440], [2560, 1600], [2560, 2048], [3200, 1800], [3200, 2048], [3200, 2400], [3440, 1440], [3840, 2160], [3840, 2400], [4096, 3072], [5120, 2880], [5120, 3200], [5120, 4096], [6400, 4096], [6400, 4800], [7680, 4320], [7680, 4800]];
    var screen_res_sel = document.getElementById('sr');
    var sr_oform = document.getElementById("sr_o");
    for (var i = 0; i < screen_res.length; i++) {
        var name = screen_res[i][0] + " x " + screen_res[i][1];
        screen_res_sel.options.add(new Option(name, ""));
    }
    screen_res_sel.options.add(new Option("other", ""));
    screen_res_sel.options[23].selected = true;
    sr_oform.style.display = "none";
    var onScreenResSelect = function() {
        sr_oform.style.display = (screen_res_sel.selectedIndex == screen_res.length ? "inline" : "none");
    };

    var screen_size = [1.33, 1.53, 2.8, 3.2, 3.3, 3.5, 3.7, 4.0, 4.2, 4.3, 4.5, 4.7, 4.8, 5.0, 5.3, 6.0, 7.0, 7.8, 8.9, 9.7, 10.0, 10.2, 11.1, 12.1, 13.3, 14.1, 15.0, 15.4, 15.6, 16.0, 17.0, 18.4, 19.0, 20.0, 21.5, 22.0, 22.1, 23.0, 24.0, 25.0, 26.0, 27.0, 28.0, 29.0, 30.0, 32.0];
    var screen_size_sel = document.getElementById('ss');
    var ss_oform = document.getElementById("ss_o");
    for (var i = 0; i < screen_size.length; i++) {
        screen_size_sel.options.add(new Option(screen_size[i], ""));
    }
    screen_size_sel.options.add(new Option("other", ""));
    screen_size_sel.options[29].selected = true;
    ss_oform.style.display = "none";
    var onScreenSizeSelect = function() {
        ss_oform.style.display = (screen_size_sel.selectedIndex == screen_size.length ? "inline" : "none");
    };

    var distance_from_screen = [10, 20, 30, 40, 50, 60, 70, 80, 90, 100];
    var distance_sel = document.getElementById('ds');
    var ds_oform = document.getElementById('ds_o');
    for (var i = 0; i < distance_from_screen.length; i++) {
        distance_sel.options.add(new Option(distance_from_screen[i], ""));
    }
    distance_sel.options.add(new Option("other", ""));
    distance_sel.options[4].selected = true;
    ds_oform.style.display = "none";
    var onDistanceSelect = function() {
        ds_oform.style.display = (distance_sel.selectedIndex == distance_from_screen.length ? "inline" : "none");
    };

    var mag_show = document.getElementById('mag_show');
    var img_div = document.getElementById('openseadragon1');
    var update_mag = function() {
        var srx, sry;
        if (screen_res_sel.selectedIndex == screen_res.length) {
            srx = parseInt(document.getElementById("sr_ox").value, 10);
            sry = parseInt(document.getElementById("sr_oy").value, 10);
        } else {
            srx = screen_res[screen_res_sel.selectedIndex][0];
            sry = screen_res[screen_res_sel.selectedIndex][1];
        }
        var sss;
        if (screen_size_sel.selectedIndex == screen_size.length) {
            sss = parseFloat(document.getElementById("ss_os").value);
        } else {
            sss = screen_size[screen_size_sel.selectedIndex];
        }
        var dsd;
        if (distance_sel.selectedIndex == distance_from_screen.length) {
            dsd = parseFloat(document.getElementById("ds_od").value);
        } else {
            dsd = distance_from_screen[distance_sel.selectedIndex];
        }

        var retJson = {
            swidth : srx, sheight : sry,
            ssize : sss, sdis: dsd,
            tlx : UpLeft_X, tly : UpLeft_Y,
            brx : DownRight_X, bry : DownRight_Y,
            iwidth : img_div.offsetWidth, iheight : img_div.offsetHeight
        };

        console.log(retJson);
        $.getJSON(
            '/_calc_mag',
            retJson,
            function(data) {
                console.log(data.status);
                $("#mag_show").text(data.mag);
            });
    }
    update_mag();

    // variable related to the manual image adjustment.
    var manLoc_x1 = 0, manLoc_y1 = 0;
    var manLoc_w = 300;

	$.getJSON('/_get_info', {}, function(data) {  //get inform and create radio button,
		console.log(data);
		MAX_X=data.img_width-1, MAX_Y=data.img_height-1;
		X=MAX_X; Y=MAX_Y;
		DownRight_X=UpLeft_X+X,DownRight_Y=UpLeft_Y+Y;
        MAX_ps_lv = data.ps_lv;
        {#Max_grading = data.grading#} // For future

        for(var i= 0 ; i<=MAX_ps_lv; i++)
        {
            var radio = document.createElement("input"); //syntax
            radio.type="radio";
            radio.name= "PS_lv";
            radio.id = "" + keyboard[i];
            radio.value=i;
            radio.onchange = function(){
                ps_lv=getRadioValue("PS_lv");}; // function is below
            var text = document.createTextNode(' '+keyboard[i]+' : ' + i +'\u00A0\u00A0\u00A0\u00A0');
            document.getElementById("PS_lv").appendChild(radio);
            document.getElementById("PS_lv").appendChild(text);
            document.getElementById(keyboard[i]).style.marginLeft = "10px";
        }

        for(var i= 0 ; i<=Max_grading; i++)
        {
            var radio = document.createElement("input");
            radio.type="radio";
            radio.name= "grading";
            radio.id = "" + i;
            radio.value=i;
            radio.onchange = function(){
                grading=getRadioValue("grading");};
            if(i==0){
                var text = document.createTextNode(' '+'Healthy'+'\u00A0\u00A0\u00A0\u00A0');
            }
            else {
                var text = document.createTextNode(' '+i+'\u00A0\u00A0\u00A0\u00A0');
            }

            document.getElementById("grading").appendChild(radio);
            document.getElementById("grading").appendChild(text);
            document.getElementById(i.toString()).style.marginLeft = "10px";
        }

        {#document.getElementsByName("PS_lv").style.marginRight = "10px";#}
        document.getElementById("Z").checked=true;
        document.getElementById("0").checked=true;
	});


    var viewer = OpenSeadragon({
        id: "openseadragon1",
        prefixUrl: "{{ url_for('static', filename='images/') }}",
        tileSources: {
            type: 'image',
            url: "{{ slide_url }}",
        },
        minZoomImageRatio: 0,
        maxZoomPixelRatio: 30,

        gestureSettingsMouse: {
            flickEnabled: false,
        },

        springStiffness: 10,
        animationTime: 0.5,

        zoomPerSecond: 0.5,
        zoomPerScroll: 1.3,
        {#blendTime: 1,#}

	});

    // For both ps_lv and grading ratio buttons.
    var getRadioValue = function(name){ //get which item is chosen (name is radio name such as "PS_lv" and "grading")
        var radio_tag = document.getElementsByName(name);
        for(var i=0;i<radio_tag.length;i++){
            if(radio_tag[i].checked){
                return radio_tag[i].value;
            }
        }
    };

    var recording_point = function(event) {
                    var Point_position = viewer.viewport.pointFromPixel(event.position);
                    var data_get = {
                        x : UpLeft_X + Point_position.x * X,
                        y : UpLeft_Y + Point_position.y * X,
                        grading : grading,
                        ps_lv : ps_lv,
                    };
                    data_draw[''+point_number]=data_get;
                    point_number=point_number+1;
                };

    var update_image =function() {
        viewer.setMouseNavEnabled(false);
		var data_askFor= {//asking image is larger than we see

			var1:Math.round (UpLeft_X-(DownRight_X-UpLeft_X)*buffer),    // buffer is the extra edge of the image that we load
            var2:Math.round (UpLeft_Y-(DownRight_Y-UpLeft_Y)*buffer),
            var3:Math.round (DownRight_X+(DownRight_X-UpLeft_X)*buffer),
			var4:Math.round (DownRight_Y+(DownRight_Y-UpLeft_Y)*buffer),
            var5:OCD_X_PX, var6:OCD_X_PX,   // 5 is static, var6 is change according to the image ratio.
            var7:ps_lv,
            var8: '((1400, 1600), (1450, 1650))'    // Note: This is temporary
		};

        //viewer.close();     // freeze the OSD
        if(data_askFor.var1<0){     data_askFor.var1=0;      }
        if(data_askFor.var2<0){     data_askFor.var2=0;      }
        if(data_askFor.var3>MAX_X){ data_askFor.var3=MAX_X;  }
        if(data_askFor.var4>MAX_Y){ data_askFor.var4=MAX_Y;  }
        data_askFor.var6=data_askFor.var5
                          *(data_askFor.var4-data_askFor.var2)
                          /(data_askFor.var3-data_askFor.var1);
        data_askFor.var6=Math.round (data_askFor.var6);

        console.log(data_askFor);

		$.getJSON('/_update_image', data_askFor, //asking for the new image
			function(data) {
                if(data.exit_code!=0){
                    alert("something wrong during processing image");
                }
				console.log(data);
				viewer.tileSources.url = data.slide_url;
				viewer.addTiledImage({
                    tileSource: viewer.tileSources,
                    minZoomImageRatio: 0,
                    maxZoomPixelRatio: 30,  // can be change to 10
                    success : function()
		            {
		                viewer.world.removeItem(viewer.world.getItemAt(0));
                        viewer.viewport.zoomTo((data_askFor.var3-data_askFor.var1)/
                                                                        (DownRight_X-UpLeft_X),{},true);
                        // true = no animation
			            viewer.viewport.panTo({
                        x:((DownRight_X+UpLeft_X)/2-data_askFor.var1)/(data_askFor.var3-data_askFor.var1),
                        y:((DownRight_Y+UpLeft_Y)/2-data_askFor.var2)/(data_askFor.var3-data_askFor.var1),
                        },true);
			            // x and y should be relative center coor of the img.
                        UpLeft_X=data_askFor.var1;
                        UpLeft_Y=data_askFor.var2;
                        DownRight_X=data_askFor.var3;
                        DownRight_Y=data_askFor.var4;
                        X=data_askFor.var3-data_askFor.var1;
                        Y=data_askFor.var4-data_askFor.var2;
                        viewer.setMouseNavEnabled(true)
		            },
                });
				if (enableOverlay) {
                    viewer.addSimpleImage({
                        url: '/static/s.png',
                        replace: false,
                        opacity: 1,
                        success: function () {
                            viewer.viewport.zoomTo((data_askFor.var3 - data_askFor.var1) /
                                (DownRight_X - UpLeft_X), {}, true);
                            // true = no animation
                            viewer.viewport.panTo({
                                x: ((DownRight_X + UpLeft_X) / 2 - data_askFor.var1) / (data_askFor.var3 - data_askFor.var1),
                                y: ((DownRight_Y + UpLeft_Y) / 2 - data_askFor.var2) / (data_askFor.var3 - data_askFor.var1),
                            }, true);
                            // x and y should be relative center coor of the img.
                            UpLeft_X = data_askFor.var1;
                            UpLeft_Y = data_askFor.var2;
                            DownRight_X = data_askFor.var3;
                            DownRight_Y = data_askFor.var4;
                            X = data_askFor.var3 - data_askFor.var1;
                            Y = data_askFor.var4 - data_askFor.var2;
                        },
                    });
                }
			}
		);

        update_mag();
	};

    var update_bounds = function() {
        var bounds = viewer.viewport.getBounds();

        UpLeft_X=UpLeft_X+bounds.x*X;
        UpLeft_Y=UpLeft_Y+bounds.y*X;
        DownRight_X =UpLeft_X+bounds.width*X;
        DownRight_Y =UpLeft_Y+bounds.height*X;
    };

    var update_zoom = function() { //do if pin changed
        var zoom = viewer.viewport.getZoom(true);
        var imageZoom = viewer.viewport.viewportToImageZoom(zoom);
        /*
        imageZoom>1 = zoom in more than image resolution
        zoom<1 = viewer larger than image
        (therefore) (zoom<1 && X<MAX_X) = only refresh for the 1st time that viewer is larger than image.
        X is of latest image
        MAX_X is of WSI
         */
		if(imageZoom>1||(zoom<1 && X<MAX_X)){
		    // Refresh image
            update_bounds();
		    update_image();
		}
        else {update_pin();}
    };

    var update_pin = function() {//do if out of bounds
		var bounds = viewer.viewport.getBounds();
		if((bounds.x<0&&UpLeft_X>0)||
           (bounds.y<0&&UpLeft_Y>0)||
           ((bounds.x+bounds.width) >1&&DownRight_X<MAX_X)||
           ((bounds.y+bounds.height)>(Y/X) &&DownRight_Y<MAX_Y))
        {
            {#console.log(bounds);#}
            update_bounds();
            update_image();
		}
    };

    var add_overlay = function(x,y) {
        viewer.addOverlay({
            element: 'right-arrow-overlay',
            placement: 'RIGHT',
            checkResize: false,
            location: new OpenSeadragon.Point(x,y),
        });
    };

    // Run the func after user interact with OSD
    viewer.addHandler('open', function(){

		update_image(); // get first image

        var tracker = new OpenSeadragon.MouseTracker({ //set mouse tracker
                element: viewer.container,
                moveHandler: recording_point,
            });
        tracker.setTracking(false);

		viewer.addHandler('animation-finish', update_zoom);

        viewer.addHandler('canvas-nonprimary-press',  function (e) {
            if(e.button==2){
                recording_point(e);tracker.setTracking(true);}
         });
        viewer.addHandler('canvas-nonprimary-release',  function (e) {
            if(e.button==2){
                tracker.setTracking(false);


                $.post("/_record",data_draw).done(function(data){
                    console.log(data);
                    data_draw={};
                    point_number=0;
                    // Disable the image updating after the click or the drag to annotate.
		            update_bounds();
		            update_image();
		            //console.log(data.pt_false_x.length);
		            if(data.pt_false_x.length!=0){
		                for(var i=0 ; i<data.pt_false_x.length ; i++)
		                    {
		                        x = (data.pt_false_x[i] - UpLeft_X)/X;
		                        y = (data.pt_false_y[i] - UpLeft_Y)/Y;
		                        //add_overlay(x,y);
		                        //console.log(x);
		                        //console.log(y);

		                    }
		            }

                    }).fail(function(){
                        alert("ask for help") ;
                        data_draw={};
                        point_number=0;
                });
                }
        });
    });

    var toggle_boundary = function()
    {
        console.log("toggle sub-region boundary");
        $.getJSON(
            '/_tog_boun',
            {cmd: 1,},
            function(data) {
                console.log(data.status);
                $("#tog_result").text("Boundary (on/off): " + data.result);
                update_bounds();
                update_image();
            });
    };

    document.onkeydown=function(e){  //listen to the keboard;
        var key=String.fromCharCode(window.event ? e.keyCode :e.which);
        console.log(key);
        if(document.getElementById(""+key))
        {
            document.getElementById(""+key).checked=true;
            document.getElementById(""+key).onchange();
            // Disable the image updating after the click or the drag to annotate.
            {#update_bounds();#}
            {#update_image();#}
        }

        if(key == 'R' || key == 'Z' || key == 'X' || key == 'C' || key == 'T'){
            console.log('Refreshing image with a key');
            if(key == 'T'){
                toggle_boundary();
            }
            else {
                update_bounds();
                update_image();
            }
        }

    };

    </script>

<script>
    // Undo function
    $(function() {
        $('a#undo').bind('click', function() {
        $.getJSON(
            '/_undo',
            {cmd: 1,},
            //$('input[name="cmd"]').val()
            function(data) {
                console.log(data.status);
                update_bounds();
                update_image();});
        return false;
        });
    });

    // Set annotator id
    $(function() {
        $('a#anno_id').bind('click', function() {
            console.log("sending annotator id");
            $.getJSON(
                '/_annotator_id',
                {id: $('input[name="anno_id"]').val(),},
                function(data) {
                    console.log(data.status);
                    $("#annotator_result").text("Current annotator: " + data.result);
                });
            return false;
        });
    });

    // Set slide id
    $(function() {
        $('a#slide_id').bind('click', function() {
            console.log("sending slide id");
            $.getJSON(
                '/_slide_id',
                {id: $('input[name="slide_id"]').val(),},
                function(data) {
                    console.log(data.status);
                    $("#slide_result").text("Current slide: " + data.result);
                });
            return false;
        });
    });

    // Set top-left coordinate
    $(function() {
        $('a#update_img_man').bind('click', function() {
            console.log("Using manual option to update the image...");
            var bounds = viewer.viewport.getBounds();

            UpLeft_X = parseInt($('input[name="tl_x1"]').val(), 10);
            UpLeft_Y = parseInt($('input[name="tl_y1"]').val(), 10);

            manLoc_w = parseInt($('input[name="tl_x2"]').val(), 10);

            var wh_ratio = bounds.height / bounds.width;

            DownRight_X = UpLeft_X + manLoc_w;
            DownRight_Y = UpLeft_Y + (manLoc_w * wh_ratio);

            update_image();

            return false;
        });
    });

    // Toggle sub-region boundary
    $(function() {
        $('a#tog_boun').bind('click', function() {
            toggle_boundary();
            return false;
        });
    });


    </script>

<script>
		$(document).ready(function(){
  			$("#clinical_meta_data").click(function(){
    		$("#patient_info").slideToggle("slow");
  			});
		});
		$(document).ready(function(){
  			$("#bio_meta_data").click(function(){
    		$("#bio_info").slideToggle("slow");
  			});
		});
		$(document).ready(function(){
  			$("#demographic").click(function(){
    		$("#demographic_info").slideToggle("slow");
    		var data=JSON.stringify('demographic');
    		$.ajax({
					type:'POST',
					url:'/get_patient_meta/',
					async:true,
                    data:data,
					contentType:'application/json',

				})
				.done(function(data){
					result=JSON.parse(data);
					$('#demographic_info').empty();
					$.each(result,function(key,value){
						//alert(key,value);
						//$('#successAlert').text(key+":"+value+'<br>').show();

						$('#demographic_info').append(key+":  "+value+'<br>');
					})
				});

				event.preventDefault();

  			});
		});
		$(document).ready(function(){
  			$("#diagnosis").click(function(){
    		$("#diagnosis_info").slideToggle("slow");
    		var data=JSON.stringify('diagnosis');
    		$.ajax({
					type:'POST',
					url:'/get_patient_meta/',
					async:true,
                    data:data,
					contentType:'application/json',

				})
				.done(function(data){
					result=JSON.parse(data);
					$('#diagnosis_info').empty();
					$.each(result,function(key,value){
						//alert(key,value);
						//$('#successAlert').text(key+":"+value+'<br>').show();

						$('#diagnosis_info').append(key+":  "+value+'<br>');
					})
				});

				event.preventDefault();

  			});
		});
		$(document).ready(function(){
  			$("#exposure").click(function(){
    		$("#exposure_info").slideToggle("slow");
    		var data=JSON.stringify('exposure');
    		$.ajax({
					type:'POST',
					url:'/get_patient_meta/',
					async:true,
                    data:data,
					contentType:'application/json',

				})
				.done(function(data){
					result=JSON.parse(data);
					$('#exposure_info').empty();
					$.each(result,function(key,value){
						//alert(key,value);
						//$('#successAlert').text(key+":"+value+'<br>').show();

						$('#exposure_info').append(key+":  "+value+'<br>');
					})
				});

				event.preventDefault();
  			});
		});
		$(document).ready(function(){
  			$("#family_history").click(function(){
    		$("#family_history_info").slideToggle("slow");
    		var data=JSON.stringify('family_history');
    		$.ajax({
					type:'POST',
					url:'/get_patient_meta/',
					async:true,
                    data:data,
					contentType:'application/json',

				})
				.done(function(data){
					result=JSON.parse(data);
					$('#family_history_info').empty();
					$.each(result,function(key,value){
						//alert(key,value);
						//$('#successAlert').text(key+":"+value+'<br>').show();

						$('#family_history_info').append(key+":  "+value+'<br>');
					})
				});

				event.preventDefault();
  			});
		});
		$(document).ready(function(){
  			$("#molecular_test").click(function(){
    		$("#molecular_test_info").slideToggle("slow");
    		var data=JSON.stringify('molecular_test');
    		$.ajax({
					type:'POST',
					url:'/get_patient_meta/',
					async:true,
                    data:data,
					contentType:'application/json',

				})
				.done(function(data){
					result=JSON.parse(data);
					$('#molecular_test_info').empty();
					$.each(result,function(key,value){
						//alert(key,value);
						//$('#successAlert').text(key+":"+value+'<br>').show();

						$('#molecular_test_info').append(key+":  "+value+'<br>');
					})
				});

				event.preventDefault();
  			});
		});
		$(document).ready(function(){
  			$("#treatment").click(function(){
    		$("#treatment_info").slideToggle("slow");
    		var data=JSON.stringify('treatment');
    		$.ajax({
					type:'POST',
					url:'/get_patient_meta/',
					async:true,
                    data:data,
					contentType:'application/json',

				})
				.done(function(data){
					result=JSON.parse(data);
					$('#treatment_info').empty();
					$.each(result,function(key,value){
						//alert(key,value);
						//$('#successAlert').text(key+":"+value+'<br>').show();

						$('#treatment_info').append(key+":  "+value+'<br>');
					})
				});

				event.preventDefault();
  			});
		});
		$(document).ready(function(){
  			$("#follow_up").click(function(){
    		$("#follow_up_info").slideToggle("slow");
    		var data=JSON.stringify('follow_up');
    		$.ajax({
					type:'POST',
					url:'/get_patient_meta/',
					async:true,
                    data:data,
					contentType:'application/json',

				})
				.done(function(data){
					result=JSON.parse(data);
					$('#follow_up_info').empty();
					$.each(result,function(key,value){
						//alert(key,value);
						//$('#successAlert').text(key+":"+value+'<br>').show();

						$('#follow_up_info').append(key+":  "+value+'<br>');
					})
				});

				event.preventDefault();
  			});
		});
		$(document).ready(function(){
  			$("#slide").click(function(){
    		$("#slide_info").slideToggle("slow");
    		var data=JSON.stringify('slide');
    		$.ajax({
					type:'POST',
					url:'/get_bio_meta/',
					async:true,
                    data:data,
					contentType:'application/json'
				})
				.done(function(data){
					result=JSON.parse(data);
					$('#slide_info').empty();
					$.each(result,function(key,value){
						//alert(key,value);
						//$('#successAlert').text(key+":"+value+'<br>').show();

						$('#slide_info').append(key+":  "+value+'<br>');
					})
				});

				event.preventDefault();
  			});
		});
		$(document).ready(function(){
  			$("#aliquot").click(function(){
    		$("#aliquot_info").slideToggle("slow");
    		var data=JSON.stringify('aliquot');
    		$.ajax({
					type:'POST',
					url:'/get_bio_meta/',
					async:true,
                    data:data,
					contentType:'application/json',

				})
				.done(function(data){
					result=JSON.parse(data);
					$('#aliquot_info').empty();
					$.each(result,function(key,value){
						//alert(key,value);
						//$('#successAlert').text(key+":"+value+'<br>').show();

						$('#aliquot_info').append(key+":  "+value+'<br>');
					})
				});

				event.preventDefault();
  			});
		});
		$(document).ready(function(){
  			$("#analyte").click(function(){
    		$("#analyte_info").slideToggle("slow");
    		var data=JSON.stringify('analyte');
    		$.ajax({
					type:'POST',
					url:'/get_bio_meta/',
					async:true,
                    data:data,
					contentType:'application/json',

				})
				.done(function(data){
					result=JSON.parse(data);
					$('#analyte_info').empty();
					$.each(result,function(key,value){
						//alert(key,value);
						//$('#successAlert').text(key+":"+value+'<br>').show();

						$('#analyte_info').append(key+":  "+value+'<br>');
					})
				});

				event.preventDefault();
  			});
		});
		$(document).ready(function(){
  			$("#portion").click(function(){
    		$("#portion_info").slideToggle("slow");
    		var data=JSON.stringify('portion');
    		$.ajax({
					type:'POST',
					url:'/get_bio_meta/',
					async:true,
                    data:data,
					contentType:'application/json',

				})
				.done(function(data){
					result=JSON.parse(data);
					$('#portion_info').empty();
					$.each(result,function(key,value){
						//alert(key,value);
						//$('#successAlert').text(key+":"+value+'<br>').show();

						$('#portion_info').append(key+":  "+value+'<br>');
					})
				});

				event.preventDefault();
  			});
		});
		$(document).ready(function(){
  			$("#sample").click(function(){
    		$("#sample_info").slideToggle("slow");
    		var data=JSON.stringify('sample');
    		$.ajax({
					type:'POST',
					url:'/get_bio_meta/',
					async:true,
                    data:data,
					contentType:'application/json',

				})
				.done(function(data){
					result=JSON.parse(data);
					$('#sample_info').empty();
					$.each(result,function(key,value){
						//alert(key,value);
						//$('#successAlert').text(key+":"+value+'<br>').show();

						$('#sample_info').append(key+":  "+value+'<br>');
					})
				});

				event.preventDefault();
  			});
		});
		$(document).ready(function(){
  			$("#read_group").click(function(){
    		$("#read_group_info").slideToggle("slow");
    		var data=JSON.stringify('read_group');
    		$.ajax({
					type:'POST',
					url:'/get_bio_meta/',
					async:true,
                    data:data,
					contentType:'application/json',

				})
				.done(function(data){
					result=JSON.parse(data);
					$('#read_group_info').empty();
					$.each(result,function(key,value){
						//alert(key,value);
						//$('#successAlert').text(key+":"+value+'<br>').show();

						$('#read_group').append(key+":  "+value+'<br>');
					})
				});

				event.preventDefault();
  			});
		});

		$(function(){
            $("#sr_update").click(function(){
                update_mag();
                return false;
            });
        });

        $(function(){
            $("#ss_update").click(function(){
                update_mag();
                return false;
            });
        });

        $(function(){
            $("#ds_update").click(function(){
                update_mag();
                return false;
            })
        })
	</script>￼

</body>
</html>
{% endblock %}